//
// Created by robin on 7/22/16.
//

#ifndef MIFARE_TOOLS_LIBNFCBUSINESS_H
#define MIFARE_TOOLS_LIBNFCBUSINESS_H


#include <libnfc_cpptools/Result.h>
#include <libnfc_cpptools/NfcDevice.h>

namespace LibNfc
{
namespace Core
{

class LibNfcInternal;

class LibNfcContext
{
public:
    LibNfcContext();
    virtual ~LibNfcContext();

    LibNfc::Utils::ResultBool init();

    void clean();

    bool isInitialized() const;

    LibNfc::Utils::Result<std::vector<std::shared_ptr<NfcDevice>>> getDevices() const;

    static std::string getLibNfcVersion();

    static std::string getMifareToolsVersion();

protected:
    std::shared_ptr<LibNfcInternal> _libNfc;
};

}; // Core
}; // LibNfc

#endif //MIFARE_TOOLS_LIBNFCBUSINESS_H
