//
// Created by robin on 7/22/16.
//

#ifndef MIFARE_TOOLS_NFCDEVICEBUSINESS_H
#define MIFARE_TOOLS_NFCDEVICEBUSINESS_H

#include <string>
#include <memory>

#include <libnfc_cpptools/Result.h>

namespace LibNfc
{
namespace Core
{

class NfcDeviceInternal;

class NfcDevice
{
public:
    NfcDevice(std::shared_ptr<NfcDeviceInternal> device);

    LibNfc::Utils::ResultBool open();

    void close();

    bool isOpened() const;

    const std::string & getConnStr() const;

    std::shared_ptr<NfcDeviceInternal> getDevice() const;

protected:
    std::shared_ptr<NfcDeviceInternal> _device;
};

}; // Core
}; // LibNfc

#endif //MIFARE_TOOLS_NFCDEVICEBUSINESS_H
